# This is the change file for MMIXware's mmix-sim under Plan 9.
# (by Lee Duhem, lee.duhem@gmail.com, February 2007)

@x
#define ARGS(list) ()
#endif
@y
#define ARGS(list) ()
#endif

@ @<Sub...@>=
void exit @,@,@[ARGS((int))@];
void exit(stat)
  int stat;
{
  if (stat==0)
    exits(nil);
  else {
     char s[5];
     snprint(s,5,"%d",stat);
     exits(s);
  }
}

@z

@x
@ We want to warn the user if the source file has changed since the
object file was written. The standard \CEE/ library doesn't provide
the information we need; so we use the \UNIX/ system function |stat|,
in hopes that other operating systems provide a similar way to do the job.
@^system dependencies@>

@<Preprocessor macros@>=
#include <sys/types.h>
#include <sys/stat.h>

@ @<Check if the source file has been modified@>=
@^system dependencies@>
{
  struct stat stat_buf;
  if (stat(file_info[cur_file].name,&stat_buf)>=0)
    if ((tetra)stat_buf.st_mtime > obj_time)
      fprintf(stderr,
         "Warning: File %s was modified; it may not match the program!\n",
@.File...was modified@>
         file_info[cur_file].name);
}
@y
@ We want to warn the user if the source file has changed since the
object file was written. The standard \CEE/ library doesn't provide
the information we need.
@^system dependencies@>

@ @<Check if the source file has been modified@>=
@^system dependencies@>
{
  Dir *dir_buf;
  if ((dir_buf = dirstat(file_info[cur_file].name)) != nil)
    if (dir_buf->mtime > (ulong)obj_time)
      fprintf(stderr,
         "Warning: File %s was modified; it may not match the program!\n",
@.File...was modified@>
         file_info[cur_file].name);
}
@z

@x
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <signal.h>
@y
#include <u.h>
#include <libc.h>
#include <stdio.h>
#include <ctype.h>

#define __STDC__

@z

@x
int main(argc,argv)
  int argc;
  char *argv[];
@y
void main(argc,argv)
  int argc;
  char *argv[];
@z

@x
  return g[255].l; /* provide rudimentary feedback for non-interactive runs */
@y
  exit(g[255].l); /* provide rudimentary feedback for non-interactive runs */
@z

@x
@ @<Initialize...@>=
signal(SIGINT,catchint); /* now |catchint| will catch the first interrupt */

@ @<Subr...@>=
void catchint @,@,@[ARGS((int))@];@+@t}\6{@>
void catchint(n)
  int n;
{
  interrupt=true;
  signal(SIGINT,catchint); /* now |catchint| will catch the next interrupt */
}
@y
@ @<Initialize...@>=
atnotify(catchint, 1); /* now |catchint| will catch the first interrupt */

@ @<Subr...@>=
int catchint @,@,@[ARGS((void *, char *))@];@+@t}\6{@>
int catchint(void *, char *n)
{
  if (n && strcmp(n, "interrupt") == 0) {
    interrupt=true;
    return 1;
  } else {
    return 0;
  }
}

@z